unit lt3n_wumpus_u1;

{$mode objfpc}{$H+}

//See
//http://sheepdogguides.com/lut/lt3n-convert-old-basic.htm
//for discussion.

//This sourcecode is NOT a completed program... though
//  it will run
//In the tutorial described above, you are invited to...
//  "Download lt3n_wumpus at the stage when the main
//     skeleton was well underway".
//THIS is the sourcecode in THAT state, at that stage
//  in the application's development.

//Program to illustrate some techniques which are
//generally useable, and particularly relevant
//to adapting old "console" apps to modern event
//driven operating systems.

//Specifically, this is a Lazarus implementation
//  of the great "Hunt the Wumpus, from PCC's
//  What To Do After You Hit Return.

//"States" and the timer event both play roles,
//as do sundry "flag" variables.

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

const kPrgmName='lt3n_wumpus';
      //==== Version of THIS CODE... ============
          kVers='19 Nov 18-1740';
      //_____  ^ ^  THIS CODE  ^ ^  _____________


  //===========================================
  //DISTRO -------   v  v  v  DISTRO v  v  v
      //First DISTRO- shell... Id was: '19 Nov 18-1740'
      //DISTRO ---- //TO BE DONE// was the -- DISTRO
      //Second DISTRO- more complete...
      //DISTRO ---- //TO BE DONE// was the -- DISTRO
  //(Distros live at at su/lut/lzips)
  kStatesAllowed=17;

type
 {Tlt3n_wumpus_f1}
  Tlt3n_wumpus_f1 = class(TForm)
    bu0: TButton;
    bu1: TButton;
    bu2: TButton;
    Button1: TButton;
    buHelp: TButton;
    buCredits: TButton;
    eUserInput: TEdit;
    laStateString: TLabel;
    laCurrentStateID: TLabel;
    laMsg: TLabel;
    laTxtCurrentStateID: TLabel;
    laTxtNotNormallyVisible: TLabel;
    laTxtMsg: TLabel;
    laTxtUserInputUse: TLabel;
    meShowUser: TMemo;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure bu0Click(Sender: TObject);
    procedure bu1Click(Sender: TObject);
    procedure bu2Click(Sender: TObject);
    procedure buCreditsClick(Sender: TObject);
    procedure buHelpClick(Sender: TObject);
    procedure eUserInputEditingDone(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    bState,bTermsDone,bAns:byte;
    boInputReceived,boFirstVisitToStatesHandler,
    boBu0Clicked,boBu1Clicked,boBu2Clicked:boolean;
    bNextTerm:byte;
    sNextOpIs:string;
    sUserEntered:string;
    sState:array[0..kStatesAllowed] of string;
    siF_inished:shortint;//(-128-127)
    bL_ocationOf,
    bM_emoryOfWhereThingsWere:array[1..20] of byte;
    //in this, the original programmers didn't
    //  "count from" 0, which often has advantages.
    //I copied what they did, as there was no
    //  particular reason, here, not to.
    //(Interpretation of lines 200, 210 of original:
    //In both L and M, element 1 holds the number of
    //     the chamber you are in.
    //Element 2 holds the chamber number for the wumpus.
    //3 & 4 tell us where the pits are.
    //5 & 6 tell us where the bats are.
    procedure MakeState(bNewState:byte);
    procedure FillSState;
    procedure SetButton(bWhich:byte;boEnabled:boolean;sCap:string);
    procedure ButtonsOff;
  public
    { public declarations }
  end;

var
  lt3n_wumpus_f1: Tlt3n_wumpus_f1;

implementation
{$R *.lfm}
{Tlt3n_wumpus_f1}

(*Overview...

"in state x" defined by value in bState.

FormCreate will normally leave the application
in state 0.

See the code in Timer1Timer for details of
what the various states deal with

=====
Wumpus:

"Session" will be from when app
   starts to when it closes... it
   may consist of one or more games.

"Game" will be a number of "rounds"...
   from the first, through to the
   one where you win or lose

"Round" will be the playing of a turn...
   hearing where you are
   deciding what to do
   hearing result
*)

procedure Tlt3n_wumpus_f1.
  FormCreate(Sender: TObject);
begin
   lt3n_wumpus_f1.caption:=
     kPrgmName+' vers:'+kVers;

   meShowUser.lines.clear;

   Timer1.interval:=200;

   eUserInput.text:='';
   Panel1.caption:='';
   laMsg.caption:='';

   FillSState;//Set up strings describing the states
   MakeState(0);//Initialize bState, display


   laTxtUserInputUse.caption:='Press the Enter key after'+
   chr(13)+'any answers are entered,'+
   chr(13)+'to say "answer complete"';

   boInputReceived:=false;//Initialize
   boFirstVisitToStatesHandler:=true;

   eUserInput.enabled:=false;
   ButtonsOff;

   meShowUser.readonly:=true;

   boBu0Clicked:=false;
   boBu1Clicked:=false;
   boBu2Clicked:=false;
end;//FormCreate


procedure Tlt3n_wumpus_f1.
  eUserInputEditingDone(Sender: TObject);
//If you came to this code from one of my earlier essays on
//  using states, you may be surprized that this isn't more
//  complex. Previously, the input HAD to be a number, for
//  the purposes of the rest of the application. In Wumpus
//  that is not the case. ANY input is acceptable... at this
//  point in the code. (It may have other requirements imposed
//  on it elsewhere, later.)
begin
  boInputReceived:=true;
  sUserEntered:=eUserInput.text;//Fill global, before...
  eUserInput.text:='';//Clear the edit box for the next
  //problem. (Happily, this does not trigger an
  //OnInputEditingDone event.)
end;//eUserInputEditingDone


procedure Tlt3n_wumpus_f1.bu0Click(Sender: TObject);
begin
  boBu0Clicked:=true;
end;

procedure Tlt3n_wumpus_f1.bu1Click(Sender: TObject);
begin
  boBu0Clicked:=false;
end;

procedure Tlt3n_wumpus_f1.bu2Click(Sender: TObject);
begin
  boBu2Clicked:=true;
end;

procedure Tlt3n_wumpus_f1.buCreditsClick(Sender: TObject);
begin
  showmessage('(improve this) Created from Wumpus in '+
  '"What to do after you hit return".');
end;

procedure Tlt3n_wumpus_f1.buHelpClick(Sender: TObject);
begin
    showmessage('(improve this) Your job: Figure out layout '+
    'of cave system, kill Wumpus. You have magic arrows.');
end;

procedure Tlt3n_wumpus_f1.
  Timer1Timer(Sender: TObject);

//SRs for Timer1Timer....
  procedure DoState0Things;//SR of Timer1Timer event handler.
  //State0: StartSession. Do whatever of 10-239 has not been
  //  put elsewhere. Has a small addition (A "Welcome" message)
  //  Instructions done with a button to call them up.
  begin
    meShowUser.lines.add('(Entered DoState0Things)');
    meShowUser.lines.add('Deal with SOME OF 10-239');
    meShowUser.lines.add('Some of in OnFormCreate,');
    meShowUser.lines.add('or elsewhere. The "Welcome" is an addition.');
    meShowUser.lines.add('Welcome to Wumpus!');
    meShowUser.lines.add('-------');
    meShowUser.lines.add('("Start Session" done)');
    meShowUser.lines.add('');
    MakeState(12);
  end;//DoState0Things

  {Retired...
  procedure DoState1Things;//SR of Timer1Timer event handler.
  //State1 StartGame
  begin
    meShowUser.lines.add('("Start Game" done)');
    meShowUser.lines.add('');
    MakeState(2);
  end;//DoState1Things
  }

{Retired...
  procedure DoState2Things;//SR of Timer1Timer event handler.
  //State2 StartRound
  begin
    meShowUser.lines.add('("Start Round" done)');
    meShowUser.lines.add('');
    MakeState(3);
  end;//DoState2Things
 }
  procedure DoState3Things;//SR of Timer1Timer event handler.
  //State3: We don't leave this until we've had an answer
  // from the universe of W, L or G. A temp stand in for
  // much of Wumpus.
  begin
   if boFirstVisitToStatesHandler then begin
     boFirstVisitToStatesHandler:=false;
     eUserInput.enabled:=true;
     eUserInput.setfocus;
     meShowUser.lines.add('(Entered DoState3Things)');
     meShowUser.lines.add('... which FOR NOW fakes');
     meShowUser.lines.add('things that will have happened before 490');
     meShowUser.lines.add('490, during State10');
     meShowUser.lines.add('This fills siF_inished with');
     meShowUser.lines.add('-1,0, or 1, which stand for');
     meShowUser.lines.add(' lost, do another round, won respectively.');
     meShowUser.lines.add('+++++++++++++++++');
     meShowUser.lines.add('Enter W, L or G for simulate "Won",');
     meShowUser.lines.add('  simulate "Lost" or simulate "Go on,');
     meShowUser.lines.add('  do another round".');
     meShowUser.lines.add('');
    end;//if boFirstVisitToStatesHandler

   if boInputReceived then begin
     boInputReceived:=false;
     sUserEntered:=UpperCase(sUserEntered);//Turns "y" to "Y"
     if (sUserEntered)='W' then begin
       siF_inished:=1;
       MakeState(6);;
       end;//user entered "W"
     if (sUserEntered)='L' then begin
       siF_inished:=-1;
       MakeState(6);;
       end;//user entered "L"
     if (sUserEntered)='G' then begin
       siF_inished:=0;
       MakeState(6);;
       end;//user entered "G"
       //If none of the above, stay in this
       //state waiting for one of them
       //to be entered.
      end;//if boInputReceived...
  end;//DoState3Things

  procedure DoState6Things;//SR of Timer1Timer event handler.
  //State6: Deals with acting according to the value
  //in F_inished. Then sets a new value in bState.');
  //Implements code SOME OF in 490-620- the EARLY
  //stages. incl request for user
  //input. Departs to multiple destinations.
  begin
   //Should not arrive here before input received earlier,
   //  and siF_inished=0 filled accorging to what that was

     //showmessage('In Do6:'+inttostr(siF_inished));
     //Using showmessage causes odd things to surface...
     //  somehow we get back to 6 or 7 from 13, 14, 15??
     if boFirstVisitToStatesHandler then begin
     boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState6Things)');
     meShowUser.lines.add('(Dealing with EARLY STAGES of 490-620)');
     if siF_inished=0 then begin //equiv of line 490-620.. leads to
         //"carry on, do another round"
         meShowUser.lines.add('You decided to '+
            'go on.');
         meShowUser.lines.add('');
         MakeState(10);//0: "GOTO 390".. (380 is a rem)
         //In this case, the "later stages" of 490-620
         //  not involved.
        end;//if siF_inished=0
     if siF_inished<0 then begin //equiv of the else of 500...
         //... leads to 520, "lose" et seq
         meShowUser.lines.add('You lost.');
         meShowUser.lines.add('');
         MakeState(7);//-1: Lost. We should now do Goto560
        end;//if siF_inished less than 0

     //And now for the last possible case...
     //... but we still need the "if...", don't we. (Think!)
     if siF_inished>0 then begin //equiv of 500, leads to 550
         meShowUser.lines.add('You won.');
         meShowUser.lines.add('');
          MakeState(7);//1: Won.// We should now do Goto560
         end;//if siF_inished greater than 0
     end;//if boFirstVisit....
  end;//DoState6Things

  procedure DoState7Things;//SR of Timer1Timer event handler.
  //State7: (Does LATER stages of one path through 490-620.
  //          Other path doesn't involve "later stages")

  begin
   if boFirstVisitToStatesHandler then begin
     //showmessage('In Do7 siF_inished is:'+inttostr(siF_inished));
     //Using showmessage causes odd things to surface...
     //  somehow we get back to 6 or 7 from 13, 14, 15??
     boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState7Things)');
     meShowUser.lines.add('LATER stages of one path through 490-620');
     meShowUser.lines.add('About to start new game. Decide:');
     meShowUser.lines.add('Same setup as before? Use buttons');
     meShowUser.lines.add('');

     eUserInput.enabled:=false;

     SetButton(0,true,'Yes');
     SetButton(2,true,'No');
     boBu0Clicked:=false;
     boBu2Clicked:=false;

    end;//if boFirstVisit...

   if boBu0Clicked then begin
     boBu0Clicked:=false;
     ButtonsOff;
     MakeState(11);
   end;

   if boBu2Clicked then begin
     boBu2Clicked:=false;
     ButtonsOff;
     MakeState(12);
   end;
  end;//DoState7Things

  procedure DoState10Things;//SR of Timer1Timer event handler.
  //State 10: Do what 380-489 did
  //Actually, 370 is last of prev block, 380 is rem for 390
  //   would be GOOD, but tedious, to change all "390"s to 380,
  //   all 389's to 379's... AND change all such with <b>'s on them.
  //   Sigh. (There are no other lines in block 370 380 390)
  //   There's a GOTO 390. Nothing "lost" by not going to 380
  begin //
   //if boFirstVisitToStatesHandler then begin
   //  boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState10Things)');
     meShowUser.lines.add('Will one day start game, do 380-489.');
     meShowUser.lines.add('New ROUND, using same setup as before,');
     meShowUser.lines.add('unless the setup has just been scrambled.');
     meShowUser.lines.add('* Nota bene: This, in final version, will');
     meShowUser.lines.add('leave values in siF_inished. Until it is');
     meShowUser.lines.add('doing that, state 10 goes to state 3,');
     meShowUser.lines.add('which lets developer fill siF_inished.');
     meShowUser.lines.add('LEAVE state 3 IN final... for debugging,');
     meShowUser.lines.add('etc... but "turn the code off" in "working"');
     meShowUser.lines.add('Wumpus.');
     meShowUser.lines.add('');

    //  end;//if boFirstVisit....
    MakeState(3);
  end;//DoStateThings

  procedure DoState11Things;//SR of Timer1Timer event handler.
  //State 11: Do things from 360-369
  begin //
   //if boFirstVisitToStatesHandler then begin
   //  boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState11Things)');
     meShowUser.lines.add('Will one day start game, do 360-369.');
     meShowUser.lines.add('New game, using same setup as before,');
     meShowUser.lines.add('unless the setup has just been scrambled.');
     meShowUser.lines.add('');
  //  end;//if boFirstVisit....
   MakeState(17);
  end;//DoStateThings

  procedure DoState12Things;//SR of Timer1Timer event handler.
  //State 12: DealWith240-359-part of restart
  var bCount:byte;
  begin // equiv of 240-359
   if boFirstVisitToStatesHandler then begin
     boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState12Things)');
     meShowUser.lines.add('DealWith240-359- create a');
     meShowUser.lines.add('a NEW setup, along the way to');
     meShowUser.lines.add('game restart.');
     meShowUser.lines.add('');
     MakeState(11);
   end;//if boFirstVisit...
  end;//DoStateThings

  procedure DoState13Things;//SR of Timer1Timer event handler.
  begin //Will lead to another round, via 390, in due course.
   if boFirstVisitToStatesHandler then begin
     boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState13Things)');
     meShowUser.lines.add('Will one day lead to do another round, frm 390');
     meShowUser.lines.add('Freezes here, for now.');
     //MakeState();//Tmp... this will NOT be
     //  remmecd out in the final code.
     end;//if boFirstVisit....
  end;//DoStateThings

  {A scrap that proved unnecessaryprocedure DoState14Things;//SR of Timer1Timer event handler.
  //LATER stages of 490-620- 2 of 2
  begin
 //  if boFirstVisitToStatesHandler then begin
  //   boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('');
     meShowUser.lines.add('');
     meShowUser.lines.add('(Entered LATER stages of 490-620- 2 of 2)');
     meShowUser.lines.add('');
     meShowUser.lines.add('');
     meShowUser.lines.add('');
     MakeState(3);
 //    end;//if boFirstVisit....
  end;//DoStateThings             }

 { procedure DoState15Things;//SR of Timer1Timer event handler.
  //Does Goto  360
  begin
   if boFirstVisitToStatesHandler then begin
     boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState15Things)');
     MakeState(11);
     end;//if boFirstVisit....
  end;//DoStateThings
  }

  {procedure DoState16Things;//SR of Timer1Timer event handler.
    //Does 377-379
    begin    //if boFirstVisitToStatesHandler then begin
   //  boFirstVisitToStatesHandler:=false;
     meShowUser.lines.add('(Entered DoState16Things)');
     meShowUser.lines.add('Will one day do 377-379.');
     meShowUser.lines.add('');
  //  end;//if boFirstVisit....
   MakeState(10);
   end;//DoStateThings}

   procedure DoState17Things;//SR of Timer1Timer event handler.
       //Does 370-379
       begin    //if boFirstVisitToStatesHandler then begin
      //  boFirstVisitToStatesHandler:=false;
        meShowUser.lines.add('(Entered DoState17Things 370-379)');
        meShowUser.lines.add('===== New Round! Hunt the Wumpus =====');
        meShowUser.lines.add('== May a keen nose be ever with you ==');
        meShowUser.lines.add('');
     //  end;//if boFirstVisit....
      MakeState(10);
  end;//DoStateThings

begin //main block of Timer1Timer

 case bState of
    0:begin
      DoState0Things;
      end;
    {1:begin
      DoState1Things;
      end;}
    {2:begin
      DoState2Things;
      end;}
    3:begin
      DoState3Things;
      end;
    6:begin
      DoState6Things
      end;
    7:begin
      DoState7Things
      end;

    10:begin
      DoState10Things;
      end;
    11:begin
      DoState11Things;
      end;
    12:begin
      DoState12Things;
      end;
    {13:begin
      DoState13Things;
      end;}
    {14:begin
      DoState14Things;
      end;}
    {15:begin
      DoState15Things;
      end;}
    {16:begin
      DoState16Things;
      end;   }
    17:begin
      DoState17Things;
      end;//; allowed here, even though Else follows
    else begin
      showmessage('An un-programmed State was entered.18b17a');
      end;//Handle default case
    end;//case
end;//Timer1Timer

procedure Tlt3n_wumpus_f1.FillSState;
var bTmp:byte;
begin
 //Establish default values...
 for bTmp:=0 to kStatesAllowed do
    sState[bTmp]:='State '+inttostr(bTmp)+' not assigned yet';
 //Over-write some of them...
 //sState[]:='';
 //These may have become slightly inaccurate... sigh.
 sState[0]:='GettingStarted-Session. Do whatever '+
     'of 10-239 has not been put elsewhere';//In use, 18 Nov 18, 13:14
// sState[1]:='not currently in use';//Was once a stub for 'GettingStarted-Game';
// sState[2]:='not currently in use';//Was once a stub for'GettingStarted-Round';
 sState[3]:='Prep for 490-fake parts of S10 which will be done by that when done.';//In use, 18 Nov 18, 13:14
 sState[6]:='DealWithBranchForWinLoseContinue-490-EARLY bits of things to 620';//In use, 18 Nov 18, 13:14
 sState[7]:='Do LATER bits of one path through 590-620';//In use, 18 Nov 18, 13:14
 sState[10]:='DealWith380-489(GOTO 380 as good as GOTO 390)';//In use, 18 Nov 18, 13:14
 sState[11]:='DealWith360-369';//In use, 18 Nov 18, 13:14, revised 14:40
 sState[12]:='DealWith240-359';//In use, 18 Nov 18, 13:14
 //Retired sState[13]:='AskWhetherToStartNewGameWithNewSetup-610';
 //Retired sState[14]:='DealWith380-389 (heart of a Round)';//In use, 18 Nov 18, 13:14
 //sState[15]:='Go do 360';
 //REtired 19 Nov 17:40 sState[16]:='DealWith377-379';//In use, 18 Nov 18, 14:40
 sState[17]:='DealWith370-376';//In use, 18 Nov 18, 14:40

end;//FillSState;

procedure Tlt3n_wumpus_f1.
  MakeState(bNewState:byte);
begin
  if (bState<>bNewState) then
     boFirstVisitToStatesHandler:=true;
  bState:=bNewState;
  laCurrentStateID.caption:=inttostr(bState);
  //laMsg.caption:=//anything you like!;
  laStateString.caption:='STATE: '+sState[bNewState];
end;//MakeState

procedure Tlt3n_wumpus_f1.
  SetButton(bWhich:byte;boEnabled:boolean;sCap:string);
begin
  case bWhich of
  0:begin
    bu0.enabled:=boEnabled;
    bu0.caption:=sCap;
    end;//case0
  1:begin
    bu1.enabled:=boEnabled;
    bu1.caption:=sCap;
    end;//case1
  2:begin
    bu2.enabled:=boEnabled;
    bu2.caption:=sCap;
    end;//case2
  end;//Case
end;//SetButton

procedure Tlt3n_wumpus_f1.
  ButtonsOff;
begin
   SetButton(0,false,'---');
   SetButton(1,false,'---');
   SetButton(2,false,'---');
end;//ButtonsOff;

end.

